classification
Title: os.makedirs('dir1/dir2', 0) always fails
Type: behavior Stage: resolved
Components: Library (Lib) Versions: Python 3.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: serhiy.storchaka Nosy List: loewis, martin.panter, pitrou, serhiy.storchaka, vajrasky
Priority: normal Keywords: patch

Created on 2013-12-08 11:09 by serhiy.storchaka, last changed 2017-03-24 11:28 by serhiy.storchaka. This issue is now closed.

Files
File name Uploaded Description Edit
os_makedirs_mode.patch serhiy.storchaka, 2013-12-08 11:09 review
os_makedirs_mode_2.patch serhiy.storchaka, 2013-12-08 16:38 review
Pull Requests
URL Status Linked Edit
PR 799 merged serhiy.storchaka, 2017-03-24 09:52
Messages (6)
msg205543 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2013-12-08 11:09
os.makedirs() can't create a directory with cleared write or list permission bits for owner when parent directories aren't created. This is because for parent directories same mode is used as for final directory.

Note that the mkdir utility creates parent directories with default mode (0o777 & ~umask).

$ mkdir -p -m 0 t1/t2/t3
$ ls -l -d t1 t1/t2 t1/t2/t3
drwxrwxr-x 3 serhiy serhiy 4096 Dec  7 22:30 t1/
drwxrwxr-x 3 serhiy serhiy 4096 Dec  7 22:30 t1/t2/
d--------- 2 serhiy serhiy 4096 Dec  7 22:30 t1/t2/t3/

The proposed patch emulates the mkdir utility.

See also issue19921.
msg205570 - (view) Author: Vajrasky Kok (vajrasky) * Date: 2013-12-08 15:42
Fails on Windows Vista.

======================================================================
FAIL: test_mode (__main__.MakedirTests)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "Lib\test\test_os.py", line 907, in test_mode
    self.assertEqual(stat.S_IMODE(os.stat(parent).st_mode), 0o775)
AssertionError: 511 != 509

----------------------------------------------------------------------
Ran 157 tests in 1.865s

FAILED (failures=1, skipped=61)
Traceback (most recent call last):
  File "Lib\test\test_os.py", line 2511, in <module>
    test_main()
  File "C:\Users\vajrasky\Code\cpython\lib\test\support\__init__.py", line 1831,
 in decorator
    return func(*args)
  File "Lib\test\test_os.py", line 2507, in test_main
    FDInheritanceTests,
  File "C:\Users\vajrasky\Code\cpython\lib\test\support\__init__.py", line 1719,
 in run_unittest
    _run_suite(suite)
  File "C:\Users\vajrasky\Code\cpython\lib\test\support\__init__.py", line 1694,
 in _run_suite
    raise TestFailed(err)
test.support.TestFailed: Traceback (most recent call last):
  File "Lib\test\test_os.py", line 907, in test_mode
    self.assertEqual(stat.S_IMODE(os.stat(parent).st_mode), 0o775)
AssertionError: 511 != 509

The permission of directory on Windows no matter what mode you give or umask you give to support.temp_umask, is always 0o777 (or 511). I think this test does not make sense in Windows.

>>> os.mkdir('cutecat', 0o555)
>>> os.mkdir('cutecat2', 0o777)
>>> os.stat('cutecat')
os.stat_result(st_mode=16895, st_ino=3940649674207852, st_dev=3960548439, st_nli
nk=1, st_uid=0, st_gid=0, st_size=0, st_atime=1386517061, st_mtime=1386517061, s
t_ctime=1386517061)
>>> os.stat('cutecat2')
os.stat_result(st_mode=16895, st_ino=5066549581050708, st_dev=3960548439, st_nli
nk=1, st_uid=0, st_gid=0, st_size=0, st_atime=1386517067, st_mtime=1386517067, s
t_ctime=1386517067)

Either that, or I am missing something.
msg205581 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2013-12-08 16:38
Thank you Vajrasky. Now this check is skipped on Windows.
msg268093 - (view) Author: Martin Panter (martin.panter) * (Python committer) Date: 2016-06-10 06:07
I’ve never considered this sort of scenario properly, so I don’t know if leaving the default mode for the parent directories is the best way or not. The obvious but more complicated alternative would be to call chmod() on all the new directories in a second step.

Anyway, if we are going to make any change, it should be documented. And I would say the current patch changes behaviour, so is probably not applicable as a bug fix.
msg268101 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-06-10 07:29
> The obvious but more complicated alternative would be to call chmod() on all the new directories in a second step.

This is dangerous, because if you create read-only or unlistable directory, you couldn't remove it without changing the permission of parent directory. shutil.rmtree() would fail.
msg290082 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2017-03-24 11:27
New changeset e304e33c16e060932d1e2cc8a030d42b02b429b5 by Serhiy Storchaka in branch 'master':
bpo-19930: The mode argument of os.makedirs() no longer affects the file (#799)
https://github.com/python/cpython/commit/e304e33c16e060932d1e2cc8a030d42b02b429b5
History
Date User Action Args
2017-03-24 11:28:49serhiy.storchakasetstatus: open -> closed
assignee: serhiy.storchaka
stage: patch review -> resolved
resolution: fixed
versions: + Python 3.7, - Python 2.7, Python 3.3, Python 3.4
2017-03-24 11:27:44serhiy.storchakasetmessages: + msg290082
2017-03-24 09:52:21serhiy.storchakasetpull_requests: + pull_request702
2016-06-10 07:29:59serhiy.storchakasetmessages: + msg268101
2016-06-10 06:07:57martin.pantersetnosy: + martin.panter
messages: + msg268093
2013-12-16 19:28:37serhiy.storchakasetnosy: + pitrou
2013-12-08 16:38:03serhiy.storchakasetfiles: + os_makedirs_mode_2.patch

messages: + msg205581
2013-12-08 15:42:19vajraskysetnosy: + vajrasky
messages: + msg205570
2013-12-08 11:09:53serhiy.storchakasetfiles: + os_makedirs_mode.patch
nosy: + loewis
keywords: + patch
2013-12-08 11:09:05serhiy.storchakacreate